// Web3DXCtl.cpp : Implementation of the CWeb3DXCtrl ActiveX Control class.

#include "stdafx.h"
#include "Web3DX.h"
#include "Web3DXCtl.h"
#include "Web3DXPpg.h"


#include "../w3d/w3d.h"


w3DSystem			sys;
w3DCamera			cam(0, 500, 7000, 0, 0, 0);
w3DRotate			rot_yaw(0, 0, 1, 0);
w3DRotate			rot_pitch(0, 1, 0, 0);
w3DTranslate		trans(0, 0, 0);
w3DGroup			attr;
w3DModelRenderer	mod;

BOOL bLeftPushed = FALSE;
BOOL bRightPushed = FALSE;

float	cur_yaw = 0.0f;
float	cur_pitch = 0.0f;
float	cur_trs_x = 0.0f;
float	cur_trs_y = 0.0f;
float	cur_trs_z = 0.0f;
CPoint	point_last;




#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


IMPLEMENT_DYNCREATE(CWeb3DXCtrl, COleControl)


/////////////////////////////////////////////////////////////////////////////
// Message map

BEGIN_MESSAGE_MAP(CWeb3DXCtrl, COleControl)
	//{{AFX_MSG_MAP(CWeb3DXCtrl)
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_WM_ERASEBKGND()
	ON_WM_SIZE()
	ON_WM_LBUTTONDBLCLK()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_RBUTTONDOWN()
	ON_WM_RBUTTONUP()
	ON_WM_MOUSEMOVE()
	//}}AFX_MSG_MAP
	ON_OLEVERB(AFX_IDS_VERB_PROPERTIES, OnProperties)
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// Dispatch map

BEGIN_DISPATCH_MAP(CWeb3DXCtrl, COleControl)
	//{{AFX_DISPATCH_MAP(CWeb3DXCtrl)
	// NOTE - ClassWizard will add and remove dispatch map entries
	//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_DISPATCH_MAP
	DISP_FUNCTION_ID(CWeb3DXCtrl, "AboutBox", DISPID_ABOUTBOX, AboutBox, VT_EMPTY, VTS_NONE)
END_DISPATCH_MAP()


/////////////////////////////////////////////////////////////////////////////
// Event map

BEGIN_EVENT_MAP(CWeb3DXCtrl, COleControl)
	//{{AFX_EVENT_MAP(CWeb3DXCtrl)
	// NOTE - ClassWizard will add and remove event map entries
	//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_EVENT_MAP
END_EVENT_MAP()


/////////////////////////////////////////////////////////////////////////////
// Property pages

// TODO: Add more property pages as needed.  Remember to increase the count!
BEGIN_PROPPAGEIDS(CWeb3DXCtrl, 1)
	PROPPAGEID(CWeb3DXPropPage::guid)
END_PROPPAGEIDS(CWeb3DXCtrl)


/////////////////////////////////////////////////////////////////////////////
// Initialize class factory and guid

IMPLEMENT_OLECREATE_EX(CWeb3DXCtrl, "WEB3DX.Web3DXCtrl.1",
	0xa4846eda, 0x60e4, 0x11d5, 0x8c, 0xe4, 0, 0x1, 0x2, 0x50, 0xd9, 0xdd)


/////////////////////////////////////////////////////////////////////////////
// Type library ID and version

IMPLEMENT_OLETYPELIB(CWeb3DXCtrl, _tlid, _wVerMajor, _wVerMinor)


/////////////////////////////////////////////////////////////////////////////
// Interface IDs

const IID BASED_CODE IID_DWeb3DX =
		{ 0xa4846ed8, 0x60e4, 0x11d5, { 0x8c, 0xe4, 0, 0x1, 0x2, 0x50, 0xd9, 0xdd } };
const IID BASED_CODE IID_DWeb3DXEvents =
		{ 0xa4846ed9, 0x60e4, 0x11d5, { 0x8c, 0xe4, 0, 0x1, 0x2, 0x50, 0xd9, 0xdd } };


/////////////////////////////////////////////////////////////////////////////
// Control type information

static const DWORD BASED_CODE _dwWeb3DXOleMisc =
	OLEMISC_ACTIVATEWHENVISIBLE |
	OLEMISC_SETCLIENTSITEFIRST |
	OLEMISC_INSIDEOUT |
	OLEMISC_CANTLINKINSIDE |
	OLEMISC_RECOMPOSEONRESIZE;

IMPLEMENT_OLECTLTYPE(CWeb3DXCtrl, IDS_WEB3DX, _dwWeb3DXOleMisc)


/////////////////////////////////////////////////////////////////////////////
// CWeb3DXCtrl::CWeb3DXCtrlFactory::UpdateRegistry -
// Adds or removes system registry entries for CWeb3DXCtrl

BOOL CWeb3DXCtrl::CWeb3DXCtrlFactory::UpdateRegistry(BOOL bRegister)
{
	// TODO: Verify that your control follows apartment-model threading rules.
	// Refer to MFC TechNote 64 for more information.
	// If your control does not conform to the apartment-model rules, then
	// you must modify the code below, changing the 6th parameter from
	// afxRegApartmentThreading to 0.

	if (bRegister)
		return AfxOleRegisterControlClass(
			AfxGetInstanceHandle(),
			m_clsid,
			m_lpszProgID,
			IDS_WEB3DX,
			IDB_WEB3DX,
			afxRegApartmentThreading,
			_dwWeb3DXOleMisc,
			_tlid,
			_wVerMajor,
			_wVerMinor);
	else
		return AfxOleUnregisterClass(m_clsid, m_lpszProgID);
}


/////////////////////////////////////////////////////////////////////////////
// CWeb3DXCtrl::CWeb3DXCtrl - Constructor

CWeb3DXCtrl::CWeb3DXCtrl()
{
	InitializeIIDs(&IID_DWeb3DX, &IID_DWeb3DXEvents);

	// TODO: Initialize your control's instance data here.
}


/////////////////////////////////////////////////////////////////////////////
// CWeb3DXCtrl::~CWeb3DXCtrl - Destructor

CWeb3DXCtrl::~CWeb3DXCtrl()
{
	// TODO: Cleanup your control's instance data here.
}


/////////////////////////////////////////////////////////////////////////////
// CWeb3DXCtrl::OnDraw - Drawing function

void CWeb3DXCtrl::OnDraw(
			CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid)
{
	sys.Process();
	w3DFlushAndSwap();
}


/////////////////////////////////////////////////////////////////////////////
// CWeb3DXCtrl::DoPropExchange - Persistence support

void CWeb3DXCtrl::DoPropExchange(CPropExchange* pPX)
{
	ExchangeVersion(pPX, MAKELONG(_wVerMinor, _wVerMajor));
	COleControl::DoPropExchange(pPX);

	// TODO: Call PX_ functions for each persistent custom property.

}


/////////////////////////////////////////////////////////////////////////////
// CWeb3DXCtrl::OnResetState - Reset control to default state

void CWeb3DXCtrl::OnResetState()
{
	COleControl::OnResetState();  // Resets defaults found in DoPropExchange

	// TODO: Reset any other control state here.
}


/////////////////////////////////////////////////////////////////////////////
// CWeb3DXCtrl::AboutBox - Display an "About" box to the user

void CWeb3DXCtrl::AboutBox()
{
	CDialog dlgAbout(IDD_ABOUTBOX_WEB3DX);
	dlgAbout.DoModal();
}



void GetModuleDirectory(char *mod, char *out)
{
  int len, i;

  GetModuleFileName(GetModuleHandle(mod), out, MAX_PATH);

  len = strlen(out);
  
  for (i=len; i>0; i--)
  {
    if (out[i] == '\\')
    {
      out[i] = NULL;
      break;
    }
  }
}


/////////////////////////////////////////////////////////////////////////////
// CWeb3DXCtrl message handlers

int CWeb3DXCtrl::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (COleControl::OnCreate(lpCreateStruct) == -1)
		return -1;

	sys.AdjustCSInfo(*lpCreateStruct);
	// set active camera
	sys.SetActiveCamera(&cam);
	sys.Init(m_hWnd);

	char dirbuf[MAX_PATH];
	GetModuleDirectory("WEB3DX.OCX", dirbuf);
	::SetCurrentDirectory(dirbuf);
		
	mod.Init("out.bin");

	attr.Empty();
	attr.Add(&trans);
	attr.Add(&rot_pitch);
	attr.Add(&rot_yaw);
	mod.SetAttrib(&attr);

	// register the scene
	sys.SetModeler(&mod);
	sys.Resume();

	return 0;
}

void CWeb3DXCtrl::OnDestroy() 
{
	COleControl::OnDestroy();
	
	sys.Stop();	
}

BOOL CWeb3DXCtrl::OnEraseBkgnd(CDC* pDC) 
{
	return FALSE;
}

void CWeb3DXCtrl::OnSize(UINT nType, int cx, int cy) 
{
	COleControl::OnSize(nType, cx, cy);
	
	sys.Resize(cx, cy);
	Invalidate();	
}

void CWeb3DXCtrl::OnLButtonDblClk(UINT nFlags, CPoint point) 
{
	unsigned long id = sys.PickObject(point.x, point.y);

	if (id > 0)
	{
		STRUCT_OBJECT*	pTarget;
		mod.QueryObject(id, (void**)&pTarget);
		w3DWinMsg("name: %s\n", pTarget->name);
	}
	
	COleControl::OnLButtonDblClk(nFlags, point);
}

void CWeb3DXCtrl::OnLButtonDown(UINT nFlags, CPoint point) 
{
	SetCapture();

	bLeftPushed = TRUE;
	
	COleControl::OnLButtonDown(nFlags, point);
}

void CWeb3DXCtrl::OnLButtonUp(UINT nFlags, CPoint point) 
{
	ReleaseCapture();

	bLeftPushed = FALSE;
	
	COleControl::OnLButtonUp(nFlags, point);
}

void CWeb3DXCtrl::OnRButtonDown(UINT nFlags, CPoint point) 
{
	SetCapture();

	bRightPushed = TRUE;
	
	COleControl::OnRButtonDown(nFlags, point);
}

void CWeb3DXCtrl::OnRButtonUp(UINT nFlags, CPoint point) 
{
	ReleaseCapture();

	bRightPushed = FALSE;
	
	COleControl::OnRButtonUp(nFlags, point);
}

void CWeb3DXCtrl::OnMouseMove(UINT nFlags, CPoint point) 
{
	if (bLeftPushed && bRightPushed)
	{
		// It means 'PANNING' operation.
		cur_trs_x += (float)(point.x - point_last.x);
		cur_trs_y -= (float)(point.y - point_last.y);
		trans.Set(cur_trs_x, cur_trs_y, cur_trs_z);

		Invalidate();
	}
	else if (bLeftPushed)
	{
		// It means 'ROTATION' operation.
		cur_yaw += (float)(point.x - point_last.x);
		rot_yaw.SetAngle(cur_yaw);

		cur_pitch += (float)(point.y - point_last.y);
		if (cur_pitch > 90.0f)
			cur_pitch = 90.0f;
		if (cur_pitch < -90.0f)
			cur_pitch = -90.0f;

		rot_pitch.SetAngle(cur_pitch);

		Invalidate();
	}
	else if (bRightPushed)
	{
		// It means 'ZOOM' operation.
		cur_trs_z += (float)(point.y - point_last.y);
		trans.Set(cur_trs_x, cur_trs_y, cur_trs_z);

		Invalidate();
	}

	point_last = point;	
	COleControl::OnMouseMove(nFlags, point);
}
