
// Rev.1
// BRSZ: A FAST IMAGE SCALING ALGORITHM USING BRESENHAM'S LINE ALGORITHM
//       THE ALGORITHM HAS BEEN ORIGINALLY CREATED BY JINHONG-KIM IN 1998

// NOTE: THE ALGORITHM IS ONLY IMPLEMENTED FOR UP-SCALING PROCESS.

// (C) Copyright 1998-2001 by Jinhong Kim.
// YOU CAN USE THIS ALGORITHM AS YOU WANT FREELY WITH NO CHARGE.

#include <stdlib.h>

inline void __putpixel24(char* bm, char* c, int x, int y, int w)
{
	register char* ofs = bm+x*3+w*y*3;
	*ofs=*c; *(ofs+1)=*(c+1); *(ofs+2)=*(c+2);
}

inline void __getpixel24(char* bm, char* c, int x, int y, int w)
{
	register char* ofs = bm+x*3+w*y*3;
	*c=*ofs; *(c+1)=*(ofs+1); *(c+2)=*(ofs+2);
}


void FastZoom24(char* src, int sw, int sh, char** dest, int dw, int dh)
{
	int px, py = -dh;
	int x2sw = (sw+sw), x2swdw = 2*(sw-dw);
	int x2sh = (sh+sh), x2shdh = 2*(sh-dh);
	int spx=0, spy=0, dpx=0, dpy=0;
	char bf[3];
	
	*dest = (char*)malloc(dw*dh*3);
	while (dpy < dh)
	{
		dpx = 0; spx = 0; px = -dw;
		__getpixel24(src, bf, spx, spy, sw);
		while (dpx < dw)
		{
			__putpixel24(*dest, bf, dpx++, dpy, dw);
			if (px <= 0) px += x2sw;
			else
			{
				__getpixel24(src, bf, ++spx, spy, sw);
				px += x2swdw;
			}
		}
		if (py <= 0) py += x2sh;
		else
		{
			spy++;
			py += x2shdh;
		}
		dpy++;
	}
}

void FastZoom8(char* src, int sw, int sh, char** dest, int dw, int dh)
{
	int px, py = -dh;
	int x2sw = (sw+sw), x2swdw = 2*(sw-dw);
	int x2sh = (sh+sh), x2shdh = 2*(sh-dh);
	int spx=0, spy=0, dpx=0, dpy=0;
	char bf;
	
	*dest = (char*)malloc(dw*dh*3);
	while (dpy < dh)
	{
		dpx = 0; spx = 0; px = -dw;
		bf = *(src+spx+spy*sw);
		while (dpx < dw)
		{
			*(*dest+dpx+dpy*dw) = bf;
			dpx++;
			if (px <= 0) px += x2sw;
			else
			{
				++spx;
				bf = *(src+spx+spy*sw);
				px += x2swdw;
			}
		}
		if (py <= 0) py += x2sh;
		else
		{
			spy++;
			py += x2shdh;
		}
		dpy++;
	}
}

